(:
 : Copyright (c) 2014-2015 Jean-Marc Mercier
 : Licensed under the Apache License, Version 2.0 (the "License");
 : you may not use this file except in compliance with the License.
 : You may obtain a copy of the License at
 :
 :     http://www.apache.org/licenses/LICENSE-2.0
 :
 : Unless required by applicable law or agreed to in writing, software
 : distributed under the License is distributed on an "AS IS" BASIS,
 : WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 : See the License for the specific language governing permissions and
 : limitations under the License.
 :)
import module namespace idmap="http://www.crimere.com/idmap" at "idmap.xqm";
import module namespace set="http://www.crimere.com/set" at "set.xqm";

(:-----------------profiler functions---------------:) 
declare function local:integer_sequence($nb)                  {for $i in 1 to xs:integer($nb) return $i};
declare function local:integer_pair_sequence($nb)             {for $i in 1 to xs:integer($nb) return set:pair($i,$i)};
declare function local:integer_entry_sequence($nb)            {for $i in 1 to xs:integer($nb) return map:entry($i,$i)};
declare function local:node_sequence($nb)                     {for $i in 1 to xs:integer($nb) return element{"dummy"}{$i}};
declare function local:node_pair_sequence($nb)                {for $i in 1 to xs:integer($nb) return set:pair(element{"dummy"}{$i},element{"dummy"}{$i})};

declare function local:profile($i,$j)
{
    for $nb in $i to $j
    let $pow := math:pow(2,$nb)
    let $dummy :=
    (
    fn:trace("","<test>")
    ,fn:trace("","<nb>"),fn:trace(math:pow(2,$nb),""),fn:trace("","</nb>")
    ,fn:trace("","<integer_set>"),fn:trace(let $dummy := prof:time(set:count(
            set:set(set:set(function($el) as xs:anyAtomicType {$el}),local:integer_sequence($pow))
    )) return "",""),fn:trace("","</integer_set>")
    ,fn:trace("","<node_set>"),fn:trace(let $dummy := prof:time(set:count(
        set:set(set:set(function($el) as xs:anyAtomicType {xs:integer(fn:data($el))}), local:node_sequence($pow))
     )) return "",""),fn:trace("","</node_set>")
    ,fn:trace("","<integer_map>"),fn:trace(let $dummy := prof:time(idmap:count(
        idmap:idmap(idmap:idmap(function($el) as xs:anyAtomicType {$el}),local:integer_pair_sequence($pow))
     )) return "",""),fn:trace("","</integer_map>")
    ,fn:trace("","<Basex_integer_map>"),fn:trace(let $dummy := prof:time(map:size(
        map:new( (map:new(), local:integer_entry_sequence($pow)) )
     )) return "",""),fn:trace("","</Basex_integer_map>")
    ,fn:trace("","<node_map>"),fn:trace(let $dummy := prof:time(idmap:count(
        idmap:idmap(idmap:idmap(function($el) as xs:anyAtomicType {xs:integer($el)}),local:node_pair_sequence($pow))
     )) return "",""),fn:trace("","</node_map>")
    ,fn:trace("","</test>") 
    )
    return ()
};
                                                                                                
local:profile(10,20)


(:
let $xquery := "import module namespace idmap='http://www.crimere.com/idmap';" ||  "idmap:profile(10,11)"

let $id := client:connect('', 1984, 'admin', 'admin')
return (client:query($id, $xquery), client:close($id))

import module namespace common="http://www.crimere.com/common" at "../common.xqm";
 import module namespace set="http://www.crimere.com/set" at "set.xqm";
import module namespace idmap="http://www.crimere.com/idmap" at "idmap.xqm";


:)